org.eclipse.viatra.addon.querybasedfeatures.runtime.handler

## Class SumQueryBasedFeature

- java.lang.Object
- - org.eclipse.viatra.addon.querybasedfeatures.runtime.QueryBasedFeature
  - - org.eclipse.viatra.addon.querybasedfeatures.runtime.handler.IterationQueryBasedFeature
    - - org.eclipse.viatra.addon.querybasedfeatures.runtime.handler.SumQueryBasedFeature

-     public class SumQueryBasedFeature
      extends IterationQueryBasedFeature

  FIXME write AggregateHandler if any EDataType should be allowed TODO notifications could be static final? to ensure message ordering

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `SumQueryBasedFeature(org.eclipse.emf.ecore.EStructuralFeature feature, QueryBasedFeatureKind kind)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getIntValue(java.lang.Object source)`
    `QueryBasedFeatureKind` | `getKind()`
    `java.lang.Object` | `getValue(java.lang.Object source)`
    `java.lang.Object` | `getValueIteration(java.lang.Object source)`
    `protected org.eclipse.emf.ecore.impl.ENotificationImpl` | `lostMatchIteration(IPatternMatch signature)` Called each time when a match is lost for Iteration kind
    `protected org.eclipse.emf.ecore.impl.ENotificationImpl` | `newMatchIteration(IPatternMatch signature)` Called each time when a new match is found for Iteration kind

    - ### Methods inherited from class org.eclipse.viatra.addon.querybasedfeatures.runtime.handler.IterationQueryBasedFeature

      `afterUpdate, beforeUpdate, processAppearedMatch, processDisappearedMatch`

    - ### Methods inherited from class org.eclipse.viatra.addon.querybasedfeatures.runtime.QueryBasedFeature

      `appendNotificationToList, engineForMatcher, getFeature, getMatcher, getSourceParamName, getSourceValue, getTargetParamName, getTargetValue, initialize, isCached, isInitialized, setMatcher, setSourceParamName, setTargetParamName, startMonitoring`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SumQueryBasedFeature

          protected SumQueryBasedFeature(org.eclipse.emf.ecore.EStructuralFeature feature,
                                         QueryBasedFeatureKind kind)

      Parameters:
        `feature` -
        `kind` -
        `keepCache` -

  - ### Method Detail

    - #### newMatchIteration

          protected org.eclipse.emf.ecore.impl.ENotificationImpl newMatchIteration(IPatternMatch signature)

      Description copied from class: `IterationQueryBasedFeature`
      Called each time when a new match is found for Iteration kind
      Specified by:
        `newMatchIteration` in class `IterationQueryBasedFeature`
      Returns:
        notification to be sent, if one is necessary

    - #### lostMatchIteration

          protected org.eclipse.emf.ecore.impl.ENotificationImpl lostMatchIteration(IPatternMatch signature)

      Description copied from class: `IterationQueryBasedFeature`
      Called each time when a match is lost for Iteration kind
      Specified by:
        `lostMatchIteration` in class `IterationQueryBasedFeature`
      Returns:
        notification to be sent, if one is necessary

    - #### getValueIteration

          public java.lang.Object getValueIteration(java.lang.Object source)

      Specified by:
        `getValueIteration` in class `IterationQueryBasedFeature`

    - #### getIntValue

          public int getIntValue(java.lang.Object source)

    - #### getKind

          public QueryBasedFeatureKind getKind()

      Specified by:
        `getKind` in class `QueryBasedFeature`

    - #### getValue

          public java.lang.Object getValue(java.lang.Object source)

      Overrides:
        `getValue` in class `IterationQueryBasedFeature`